# Ubuntu Continuous Integration Engine
# Copyright 2014 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify it under
# the terms of the GNU General Public License version 3, as published by the
# Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranties of MERCHANTABILITY,
# SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program.  If not, see <http://www.gnu.org/licenses/>.

import sys
import urllib2
from ci_libs import utils


def ticket_status(args):
    try:
        if args.ticket:
            url = utils.CI_URL + utils.TICKET_BASE + args.ticket + '/'
            data = utils.get(url)
        else:
            url = utils.CI_URL + utils.TICKET_BASE
            data = utils.get(url)
    except urllib2.HTTPError, exc:
        if exc.code == 404 and args.ticket:
            sys.exit("Ticket number {} not found.".format(args.ticket))
        raise
    except urllib2.URLError, exc:
        raise

    if args.ticket:
        ticket_str = u'Ticket #{}, {} is {} {}'.format(
            args.ticket, data[u'title'], data[u'current_workflow_step'],
            data[u'status'])
        print(ticket_str.encode('utf-8'))
    else:
        for d in data['objects']:
            ticket_str = u'Ticket #{}, {} is {} {}'.format(
                d['id'], d['title'], d['current_workflow_step'], d['status'])
            print(ticket_str.encode('utf-8'))
